// WWlabMp401Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "WWlabMp401.h"
#include "WWlabMp401Dlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#pragma comment(lib,"mp401.lib")
#include "mp401.h"

HANDLE hDevice;
long ADdata[6];	
/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWWlabMp401Dlg dialog

CWWlabMp401Dlg::CWWlabMp401Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CWWlabMp401Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CWWlabMp401Dlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CWWlabMp401Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWWlabMp401Dlg)
	DDX_Control(pDX, IDC_LIST1, m_List);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CWWlabMp401Dlg, CDialog)
	//{{AFX_MSG_MAP(CWWlabMp401Dlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
	ON_BN_CLICKED(IDC_BUTTON5, OnButton5)
	ON_BN_CLICKED(IDC_BUTTON6, OnButton6)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWWlabMp401Dlg message handlers

BOOL CWWlabMp401Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	hDevice=INVALID_HANDLE_VALUE;
				
	hDevice=MP401_OpenDevice(0);//
		if(hDevice==INVALID_HANDLE_VALUE)
		{ 
		Beep(1000,300);
		AfxMessageBox("δ⵽MP401ӲǷȷ");
		exit(0);	
		}
		else
		{
				m_List.InsertColumn( 0, "ͨ", LVCFMT_LEFT, 52, -1 );
	            m_List.InsertColumn( 1, "ֵ", LVCFMT_LEFT, 65, -1 );
             	m_List.InsertColumn( 2, "ѹֵ(V)", LVCFMT_LEFT, 72, -1 );
					//бʾͨ
	        for(int i=0; i<=6; i++)
			{
		      CString a;
		      a.Format("  %i",i);
	 	      m_List.InsertItem(i,a);
			}
	int j;
	MP401_ADSET(hDevice,0, 0,0);
	MP401_CAL(hDevice);
	do
	{
		j=MP401_CALPOLL(hDevice);

	}while(j!=0);
	

		}


	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CWWlabMp401Dlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CWWlabMp401Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CWWlabMp401Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CWWlabMp401Dlg::OnButton1() 
{
	// TODO: Add your control notification handler code here

	
	int i;
	int j;
		char Buff1[16][1000];//ֵ
		char Buff2[16][1000];//ѹֵ
   
	//б
	for(i=0;i<=6;i++)
	{
		m_List.SetItemText(i, 1,"");
		m_List.SetItemText(i, 2, "");

	}

	for(i=0;i<=6;i++)
	{
		MP401_ADSET(hDevice,i, 0,0);

	    MP401_ADDELAY(hDevice);//ʱ

		MP401_ADRUN(hDevice);//AD
	   	
		do
		{
		
			j=MP401_ADREAD(hDevice,ADdata);

		}while(j!=0);

		sprintf(Buff2[0], "%d", ADdata[0]);//תֵͨ
	    sprintf(Buff1[0], "%5.6fV", (ADdata[0]- 8388608) * 5.0 /8388608);//ֵͨתΪѹֵ
	
		m_List.SetItemText(i, 1,Buff2[0]);
		m_List.SetItemText(i, 2, Buff1[0]);


	}

	
}

void CWWlabMp401Dlg::OnButton2() 
{
	// TODO: Add your control notification handler code here
	int i;
	char Buff3[6][1000];//ֵ
	char Buff4[6][1000];//ѹֵ
    
	//б
	for(i=0;i<=6;i++)
	{
		m_List.SetItemText(i, 1,"");
		m_List.SetItemText(i, 2, "");

	}
	MP401_ADSET(hDevice,0,0,0);

	MP401_ADDELAY(hDevice);//ʱ

	MP401_ADRUN(hDevice);
	do
	{
		i=MP401_ADREAD(hDevice,ADdata);

	}while(i!=0);


	sprintf(Buff3[0], "%d", ADdata[0]);//תֵͨ
	sprintf(Buff4[0], "%5.6fV", (ADdata[0]- 8388608) * 5.0 /8388608);//ֵͨתΪѹֵ
    	
 
	m_List.SetItemText(0, 1, Buff3[0]);
    m_List.SetItemText(0, 2, Buff4[0]);

	
}

void CWWlabMp401Dlg::OnButton3() 
{
	// TODO: Add your control notification handler code here

   MP401_DA(hDevice,0,4059);

	
}

void CWWlabMp401Dlg::OnButton4() 
{
	// TODO: Add your control notification handler code here
		//IO
	MP401_DO(hDevice, 0xAA);
	
}

void CWWlabMp401Dlg::OnButton5() 
{
	// TODO: Add your control notification handler code here
		CString data, IO_IN;
	long DIData;

	//IO
	DIData=MP401_DI(hDevice);

	//IOתΪʮݣ0x00xffffʾ
	IO_IN.Format("0x%x",DIData);
	GetDlgItem(IDC_EDIT1)->SetWindowText(IO_IN);
	
}

void CWWlabMp401Dlg::OnButton6() 
{
	// TODO: Add your control notification handler code here
	     int zdata_sp10;
		 int zdata_sp80;
		 //sp=10Hz
	     MP401_ADSET(hDevice,7,2,0);
		 MP401_CAL(hDevice);
		 while(MP401_CALPOLL(hDevice)!=0);
		
		 MP401_ADRUN(hDevice);

         while(MP401_ADREAD(hDevice,ADdata)!=0);
		 
		 zdata_sp10=ADdata[0]-0x800000;

		 //sp=80Hz
	     MP401_ADSET(hDevice,7,2,1);
		 MP401_CAL(hDevice);
		 while(MP401_CALPOLL(hDevice)!=0);
		
		 MP401_ADRUN(hDevice);

         while(MP401_ADREAD(hDevice,ADdata)!=0);
		 
		 zdata_sp80=ADdata[0]-0x800000;

		 CString a,b;
		 a.Format("%d", zdata_sp10);
		 b.Format("%d", zdata_sp80);
		 
		 GetDlgItem(IDC_EDIT2)->SetWindowText("sp10:"+a);

		 GetDlgItem(IDC_EDIT3)->SetWindowText("sp80:"+b);

}
