unit mp401u;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Edit3: TEdit;
    Timer1: TTimer;
    Edit1: TEdit;
    ListBox1: TListBox;
    GroupBox1: TGroupBox;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    GroupBox2: TGroupBox;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    GroupBox3: TGroupBox;
    RadioButton4: TRadioButton;
    RadioButton5: TRadioButton;
    Button7: TButton;
    Timer2: TTimer;
    procedure Button6Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure RadioButton3Click(Sender: TObject);
    procedure RadioButton4Click(Sender: TObject);
    procedure RadioButton5Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  hd401:ulong;
  AD_Data:array[0..6] of longint; //AD data buffer
  startch,stopch,gain,sp:integer;
  G:integer;

  
// 豸
//------------------------------------------------------------
{ Creat Device
Devicenum: Device number
hd1 handle of this device}
Function MP401_OpenDevice(DeviceNum:ulong):ulong;stdcall;external 'mp401.dll';

//----------------------------------------------------------------
//closed the device
Function MP401_CloseDevice (HANDLE:ulong):ulong;stdcall;external 'mp401.dll';

//***************************************************************************************

//DIO 

//write 16bit data to DIO
Function MP401_DO (hd ,DO_data:ulong):ulong;stdcall;external 'mp401.dll';


//read 16bit data from DIO
//data return by func
Function MP401_DI (hd:ulong):ulong;stdcall;external 'mp401.dll';

//********************************************************************************

//DA
Function MP401_DA(hDevice,ch,dadata:ulong):ulong;stdcall;external 'mp401.dll';

//********************************************************************************

//AD
Function MP401_ADRUN(hDevice:ulong):ulong;stdcall;external 'mp401.dll';
Function MP401_ADREAD(hDevice:ulong;rdata:plongint):ulong;stdcall;external 'mp401.dll';
Function MP401_ADSET(hDevice,ch,gain,sp:ulong):ulong;stdcall;external 'mp401.dll';
Function MP401_CAL(hDevice:ulong):ulong;stdcall;external 'mp401.dll';
Function MP401_CALPOLL(hDevice:ulong):ulong;stdcall;external 'mp401.dll';
Function Delay(i:integer):ulong;stdcall;


implementation

{$R *.dfm}
Function Delay(i:integer):ulong;stdcall;
begin
if i=0 then
sleep(500)
else
sleep(250);
end;
procedure TForm1.Button6Click(Sender: TObject);
begin
close;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
hd401:=MP401_OpenDevice(0);
 If hd401<> $ffffffff Then
 begin
 Form1.Caption:='MP401 Device Open OK!' ;
 startch:=0;
 stopch:=6;
 gain:=0;
 sp:=0;
 G:=1;
 ComboBox1.ItemIndex:=0;
 ComboBox2.ItemIndex:=6;
 end
 else
 begin
    Form1.caption:='Device Open Eorror!';
    Button1.Enabled:=false;
    button2.Enabled:=false;
    button3.Enabled:=false;
    button4.Enabled:=false;
    button5.Enabled:=false;
 end;



end;

procedure TForm1.Button4Click(Sender: TObject);
var
DO_data:ulong;
begin
DO_data:= $AA;
MP401_DO(hd401, DO_data);//write DO 0-ffff
edit1.Text:='Ox'+inttohex(DO_data,2);
end;
procedure TForm1.Button5Click(Sender: TObject);
var
DI_Data:ulong;
begin

    DI_Data := MP401_DI(hd401);// 'read DI

    edit3.Text:='Ox'+ inttohex(DI_Data,2);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
MP401_DA(hd401,0,4095)//ͨ0ѹ10V

end;

procedure TForm1.Button1Click(Sender: TObject);
var
stop:integer;
begin
timer2.Enabled:=false;
MP401_ADSET(hd401,startch,gain,sp);
MP401_CAL(hd401);
repeat
stop:=MP401_CALPOLL(hd401);
until stop=0;
timer1.Enabled:=true;
form1.Caption:='ͨ. . . . .  ';
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
ReturnData:longint;//return AD data length
tmp:string;
m:longint;
n:real;
i:integer;

begin
listbox1.Clear;
for i:=startch to stopch  do
begin
MP401_ADSET(hd401,i,gain,sp);
//Delay(sp);
//***************************************************
MP401_ADRUN(hd401);
repeat
ReturnData:=MP401_ADREAD(hd401,@AD_Data[i]);
until ReturnData=0;
MP401_ADRUN(hd401);
repeat
ReturnData:=MP401_ADREAD(hd401,@AD_Data[i]);
until ReturnData=0;
MP401_ADRUN(hd401);
repeat
ReturnData:=MP401_ADREAD(hd401,@AD_Data[i]);
until ReturnData=0;
MP401_ADRUN(hd401);
repeat
ReturnData:=MP401_ADREAD(hd401,@AD_Data[i]);
until ReturnData=0;
MP401_ADRUN(hd401);
repeat
ReturnData:=MP401_ADREAD(hd401,@AD_Data[i]);
until ReturnData=0;

//*************************************************
MP401_ADRUN(hd401);
repeat
ReturnData:=MP401_ADREAD(hd401,@AD_Data[i]);
until ReturnData=0;

m:=AD_Data[i];
n:=(AD_Data[i] - $800000) * 5/ $800000/G;
tmp:='CH' +inttostr(i)+'   ' +format('%4d',[m])+'   ' + format('%.6f',[n])+'V' ;
listbox1.Items.Add(tmp);
end;
form1.Caption:='ͨʾ ';

end;

procedure TForm1.Button2Click(Sender: TObject);
begin
if timer1.Enabled=true then
timer1.Enabled:=false;
if timer2.Enabled=true then
timer2.Enabled:=false;
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
var
ch:integer;
stop:integer;
begin
ch:=ComboBox1.ItemIndex;
case ch of
0:startch:=0;
1:startch:=1;
2:startch:=2;
3:startch:=3;
4:startch:=4;
5:startch:=5;
6:startch:=6;
end;
if startch>stopch then
begin
showmessage('ʼͨСڵֹͨ');
ComboBox1.ItemIndex:=0;
ComboBox2.ItemIndex:=6;
startch:=0;
stopch:=6;
end;
MP401_ADSET(hd401,startch,gain,sp);
MP401_CAL(hd401);
repeat
stop:=MP401_CALPOLL(hd401);
until stop=0;
end;

procedure TForm1.ComboBox2Change(Sender: TObject);
var
ch:integer;
begin
ch:=ComboBox2.ItemIndex;
case ch of
0:stopch:=0;
1:stopch:=1;
2:stopch:=2;
3:stopch:=3;
4:stopch:=4;
5:stopch:=5;
6:stopch:=6;
end;
if startch>stopch then
begin

showmessage('ʼͨСڵֹͨ');
ComboBox2.ItemIndex:=6;
ComboBox1.ItemIndex:=0;
stopch:=6;
startch:=0;
end;
end;

procedure TForm1.RadioButton1Click(Sender: TObject);
var
stop:integer;
begin
 if radiobutton1.Checked then
begin
gain:=0;
G:=1;
end
else if radiobutton2.Checked then
begin
gain:=1;
G:=2;
end
else
begin
gain:=2;
G:=64;
end;
MP401_ADSET(hd401,startch,gain,sp);
MP401_CAL(hd401);
repeat
stop:=MP401_CALPOLL(hd401);
until stop=0;
end;
procedure TForm1.RadioButton2Click(Sender: TObject);
var
stop:integer;
begin
 if radiobutton1.Checked then
begin
gain:=0;
G:=1;
end
else if radiobutton2.Checked then
begin
gain:=1;
G:=2;
end
else
begin
gain:=2;
G:=64;
end;
MP401_ADSET(hd401,startch,gain,sp);
MP401_CAL(hd401);
repeat
stop:=MP401_CALPOLL(hd401);
until stop=0;

end;

procedure TForm1.RadioButton3Click(Sender: TObject);
var
stop:integer;
begin
 if radiobutton1.Checked then
begin
gain:=0;
G:=1;
end
else if radiobutton2.Checked then
begin
gain:=1;
G:=2;
end
else
begin
gain:=2;
G:=64;
end;
MP401_ADSET(hd401,startch,gain,sp);
MP401_CAL(hd401);
repeat
stop:=MP401_CALPOLL(hd401);
until stop=0;

end;

procedure TForm1.RadioButton4Click(Sender: TObject);
var
stop:integer;
begin
if radiobutton4.Checked then
sp:=0
else
sp:=1;
MP401_ADSET(hd401,startch,gain,sp);
MP401_CAL(hd401);
repeat
stop:=MP401_CALPOLL(hd401);
until stop=0;
end;

procedure TForm1.RadioButton5Click(Sender: TObject);
var
stop:integer;
begin
if radiobutton4.Checked then
sp:=0
else
sp:=1;
MP401_ADSET(hd401,startch,gain,sp);
MP401_CAL(hd401);
repeat
stop:=MP401_CALPOLL(hd401);
until stop=0;
end;

procedure TForm1.Button7Click(Sender: TObject);
var
stop:integer;
begin
timer1.Enabled:=false;
MP401_ADSET(hd401,startch,gain,sp);
MP401_CAL(hd401);
repeat
stop:=MP401_CALPOLL(hd401);
until stop=0;
combobox2.Enabled:=false;
timer2.Enabled:=true;
form1.Caption:='ͨ ';
end;

procedure TForm1.Timer2Timer(Sender: TObject);
var
 ReturnData:ulong;
 m:integer;
 n:real;
 tmp:string;
begin
listbox1.Clear;
MP401_ADRUN(hd401);
repeat
ReturnData:=MP401_ADREAD(hd401,@AD_Data[0]);
until ReturnData=0;
m:=AD_Data[0];
n:=(AD_Data[0] - $800000) * 5/ $800000/G;
tmp:='CH' +inttostr(startch)+'   ' +format('%4d',[m])+'   ' + format('%.6f',[n])+'V' ;
listbox1.Items.Add(tmp);
end;

end.
